/*  OpenTally: Open-source election vote counting
 *  Copyright © 2021 Lee Yingtong Li (RunasSudo)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.
 *
 *  You should have received a copy of the GNU Affero General Public License
 *  along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

mod utils;

use opentally::election::Election;
use opentally::numbers::Rational;
use opentally::stv;

use csv::StringRecord;
use flate2::bufread::GzDecoder;

use std::fs::File;
use std::io::{self, BufRead}; 

#[test]
fn aec_tas19_rational() {
	// Read CSV file
	let reader = csv::ReaderBuilder::new()
		.has_headers(false)
		.from_path("tests/data/aec-senate-formalpreferences-24310-TAS.csv")
		.expect("IO Error");
	let records: Vec<StringRecord> = reader.into_records().map(|r| r.expect("Syntax Error")).collect();
	
	let mut candidates: Vec<&str> = records.iter().skip(2).map(|r| &r[0]).collect();
	// Remove exhausted/LBF rows
	candidates.truncate(candidates.len() - 2);
	
	// TODO: Validate candidate names
	
	let stages: Vec<usize> = records.first().unwrap().iter().skip(1).step_by(2).map(|s| s.parse().unwrap()).collect();
	
	// Decompress BLT
	let file = File::open("tests/data/aec-senate-formalpreferences-24310-TAS.blt.gz").expect("IO Error");
	let file_reader = io::BufReader::new(file);
	let gz_decoder = GzDecoder::new(file_reader);
	let gz_reader = io::BufReader::new(gz_decoder);
	let lines = gz_reader.lines();
	
	// Read BLT
	let election: Election<Rational> = Election::from_blt(lines.map(|r| r.expect("IO Error").to_string()).into_iter());
	
	let stv_opts = stv::STVOptions {
		round_tvs: None,
		round_weights: None,
		round_votes: Some(0),
		round_quota: Some(0),
		quota: stv::QuotaType::Droop,
		quota_criterion: stv::QuotaCriterion::GreaterOrEqual,
		quota_mode: stv::QuotaMode::Static,
		surplus: stv::SurplusMethod::UIG,
		surplus_order: stv::SurplusOrder::ByOrder,
		transferable_only: false,
		exclusion: stv::ExclusionMethod::ByValue,
		bulk_exclude: true,
		defer_surpluses: false,
		pp_decimals: 2,
	};
	
	utils::validate_election(stages, records, election, stv_opts);
}
